       PROGRAM CAKINIT

C A PROGRAM WRITTEN TO CREATE THE CAK.init FILE FOR USE IN VH-1. 
C THIS VERSION IS WRITTEN TO CREATE THE INITIAL CONDITIONS FOR A
C SPHERICALLY SYMMETRIC CAK MODEL IN 1-D.
C
C TOM MADURA  9/05
C
C
C SPECIFY NEEDED CONSTANTS
C
C    
      integer nzones, nzonesadded, sum, n
      real xmin, xmax, xmin2, xmax2, dxfac, tmp, tmps, rrho
      real xa(350), dx(350), maxdx(350)   
      real zxa(350), zdx(350)   
      real zux(350),rho(350),pressure(350)
C
C
       G = 6.67e-8
       Pi = 3.14159
       Rstar = 6.33e11
       Smass = 2.57e34
       Rho0 = 1.2e-11
       asnd = 1.836e6
       k = 1.38e-16
       T = 2.44e4
       H = 7.9e8
       SRs = 6.3537e11
       Vinf = 1.62e8
       SMdot = 5.8e18
       Rgas = 1.38e8
       Imax1 = 200
c      Imax2 = 600
       Ncol = 9
       dx0 = 0.0
       dx1 = 0.0
       dxfac = 1.025
       xmin = 6.33e11
       xmax = 1.5825e12
c      xmax2 = 6.33e13
       Istep0 = 000000
       Time0 = 0.00
       Rsclin = 6.33e11
       Vsclin = 0.1e1
       Rhosclin = 0.1e1

C
C
      nzones = Imax1
      tmp = 1.
      tmps= 1. 
      do n=2,nzones
	  tmps = tmps*dxfac
          tmp  = tmp+tmps
      enddo
        if  (dx0.gt.0.)  then
	  dx(1)=dx0*xmin
          else
          dx(1) = (xmax-xmin)/tmp
      endif
      xa(1) = xmin
C
C Now, fill in dx(n), incrementing by factor dxfac each time.
C

      do n=2,nzones
         xa(n) = xa(n-1) + dx(n-1)
	 dx(n) = dx(n-1)
         if (dx0.eq.0.) then
	    dx(n) = dxfac*dx(n)        
        else
	    dx(n) = (dx1*(xa(n)-xmin)+dx0*(xmax-xa(n)))/(xmax/xmin-1.)
	 endif
      enddo
C
C  Now, fill in rest of grid using dxmax, where dxmax = x(351) - x(350)

        
c          do n = nzones+1,Imax2
c          dxmax = xa(nzones)-xa(nzones-1)
c         xa(n) = xa(nzones)+(n-(nzones))*dxmax
c      enddo
C
        OPEN(UNIT = 2, FILE='CAK4.init', STATUS='NEW', FORM='FORMATTED') 
C          WRITE(UNIT=2, FMT=125) Ncol,Imax,Istep0,Time0,Rsclin,Vsclin,Rhosclin
125    FORMAT(1X,3I4,F5.2,1P6E13.4)  
       DO 15, I = 1, Imax1
          r = xa(I)
          z = r/Rstar - 1.0
        if (r.lt.SRs) then      
           VEL = asnd*EXP((r-SRs)/H)
c           zux(i)=vel   
        else
           VEL = (Vinf-asnd)*(1-SRs/r)+asnd
c           zux(i)=vel
        endif
          rRHO = SMdot/(4*Pi*VEL*r*r)
c          rho(i)=rrho
          P = rRHO*asnd*asnd
c          pressure(i)=P
          EMPTY = 0.0
           WRITE(UNIT=2, FMT=200) I,z,VEL,rRHO,SMdot,P
200        FORMAT(1X,I4,1P9E20.12) 
C 200      FORMAT(1P11E20.12) 
15    CONTINUE
      CLOSE( 2 )
      END
