      subroutine cakfrc(uface,grav0,grav1)
C  
C Calculate the Sobolev force for use in evolve.f using the flow
C variables at the beginning of the timestep (rho,u,xa0) and
C add it to the arrays grav0 and grav1 set in forces.f.
C
      include 'global.h'
      include 'sweep.h'
      include 'zone.h'
C
c     parameter (cakamp=1.0,tcak=1.e4,stcak=5.e3,srcak=.25)
      parameter (pi=3.141592654,tpi=2.*pi,fpi=4.*pi)
      character*1 call
      integer n
      real grav0(maxsweep), grav1(maxsweep),
     &     scrch1(maxsweep), scrch2(maxsweep), 
     &     scrch3(maxsweep), scrch4(maxsweep),
     &     soblev(maxsweep), dudx(maxsweep),
     &     uface (maxsweep)
      real Funcs,inte 
C
C--------------------------------------------------------------
C
      if(sweep.eq.'x') then
C
C Sobolev force including finite disk correction:
C    Parameters abbott and cak are defined in init.f 
C    based on stellar parameters.
C
c
c        write (17,*) 'n,taum,r,v,dubdr,fcak,fsob'
         alpha = abbott
         opa   = 1. + alpha
           oma   = 1. - alpha
c           xlpert= 0.4*sin(tpi*(time/xlper+xlphase))
c           xlpert  = exp(alog(1.+(amp*(0.1/60)))*sin(tpi*(time/period+tmp))) 
c           xlpert= exp(alog(1.+xlamp)*sin(tpi*(time/xlper+xlphase)))
          xlpert=1.0
c SWITCHED THIS OFF FOR NOW! 
c JS 0412 
c        write(*,*) ' cak mod:', time, xlpert
         do n=nmin, nmax
            drz      = (dx0(n+1) + dx0(n)) / 2.0
            duz      = u(n+1) - u(n)
            dubdr1   = duz/drz
            drz      = (dx0(n) + dx0(n-1)) / 2.0
            duz      = u(n) - u(n-1)
            dubdr2   = duz/drz
            dubdr    = max(small,(dubdr1+dubdr2)/2.0)
            bf       = cak/(xa0(n)+0.5*dx0(n))**2
c           tmp      = cakamp*exp(-((time-tcak)/stcak)**2)
c           tmp      = tmp*exp(-((xa0(n)/xa0(nmin)-1.)/srcak)**2)
            bf       = bf*xlpert
            dln      = u(n)/((xa0(n)+0.5*dx0(n))*dubdr)

c            drz      = xa0(n+1)-xa0(n-1)       !**should be 2*dx0(n)???***
c            duz      = u(n+1)-u(n-1)
c            bf       = cak/(xa0(n)+0.5*dx0(n))**2
c            dubdr    = max(small,duz/drz)
c            dln      = u(n)/(xa0(n)*dubdr)

            rsbr     = rstar/(xa0(n)+0.5*dx0(n))
            beta     = (1.-dln)*(rsbr**2)

            if (beta.ge.1.) then
               
               fdfac = 1./opa
            else if (beta.lt.-1.e10) then
              
               fdfac = ((-beta)**alpha)/opa
            else if (abs(beta).gt.1.e-3) then
              
               fdfac = (1.-(1.-beta)**opa)/(beta*opa)
            else
c Correct Sign error in 1/3 factor term -SPO 7/13/07
               fdfac = 1.-0.5*alpha*beta*(1.+0.3333333*oma*beta)
            endif
c JS0412 -- Implemented stellar limb-darkening via numerical 
c integrration over angle in Qromb 
c OBS! -- FASTER VERSION ONLY CALCULATES AT TIME-STEP ncycle=0
c TEST CASE indicates ~ 25 % longer cpu-time when numerical 
c fd-correction is calcualted at *each* time step. Ok, I guess..
c            if (ncycle.eq.0) then 
            if (epsabs.lt.-1.0) then 
               funcsvi = sqrt(1.-rsbr**2)
               funcsvii = 1./dln-1.
               funcsviii = alpha 
               call Qromb(funcsvi, 1.,inte,1.e-4, 1)
               fdfac = 2.*inte/( (1.-funcsvi**2)*(1.+funcsvii)**funcsviii )
c               fdfac_ld(n) = 2.*inte/( (1.-funcsv1**2)*(1.+funcsv2)**funcsv3 )
c               r_ld(n) = 1./rsbr
            endif
c            if (epsabs.lt.-1.0) fdfac = fdfac_ld(n) 
            dubdm    = dubdr/(rho(n))
            if (dubdm.lt.0.) then
c           write(stderr,10) n,istep,time,1./rsbr,
c     $                          u(n),rho(n),dubdr,dubdm
c 10             format(' dubdm<0 error:'2i5,1p6e10.3)
               dubdm=abs(dubdm)
            endif
            fcak     = bf * dubdm**alpha
            fsob     = fcak
            taum     = xkapm * vtherm / dubdm
            fsob     = fsob * ((1.+taum)**oma - 1.) / taum**oma
c TESTING -- JS!! - NO CUT-OFF
            if (ifrc.eq.-2) fsob = fcak 
c---------------------------------------------------
            fdsk     = fsob
c           if(dubdr.gt.small) fdfac=1
            fdsk     = fdsk * fdfac
            soblev(n) = fdsk
c            if(ifrc.le.-1) soblev(n)=fsob
            if(ifrc.eq.-1) soblev(n)=fsob
            if (ifrc.eq.-3) soblev(n)=fcak
c           if (n.eq.100) write(7,*) n,ifrc,fdsk,fsob,soblev(n)
            rf = xa0(n) + 0.5*dx0(n)
c    write (*,*) n,taum,rf,u(n),dubdr,fcak,fsob
c      write(*,10) n,dubdr,soblev(n)
c10     format(' ',i5,1p2e20.8)
      enddo
C
C      soblev(nmin+1) = 2.*soblev(nmin+2) - soblev(nmin+3)
      soblev(nmin)   = 2.*soblev(nmin+1) - soblev(nmin+2)
C      soblev(nmax)   = 2.*soblev(nmax-1) - soblev(nmax-2)
      soblev(nmax+1) = 2.*soblev(nmax)   - soblev(nmax-1)
C
      do 16 n = nmin, nmax
         grav0(n) = grav0(n) + soblev(n)
         grav1(n) = grav1(n) + soblev(n)
         zgr(n-2,1,1) = soblev(n)
         zgs(n-2,1,1) = 0.
 16   continue
C
c      do 99 n = nmin-2, nmax
c       write(17,1500) n,xa0(n)/rstar,u(n),rho(n),p(n),
c     &                soblev(n) / (GM / rstar**2)
c     &                soblev(n) / (GM / (xa0(nmin)+0.5*dx0(nmin))**2)
c 99   continue
1500   format(1x,i5,1p6e11.3)
      endif
C
c      do n=nmin,nmax
c         print*,n,soblev(n)
c      enddo
c      stop'testing'

      return
      end

