      subroutine dtcon
C
C set the timestep using various constraints.
C NB - additional constraints may be required depending on the problem!
C
C
      include 'global.h'
      include 'zone.h'
      integer i, j, k
c      parameter (dtmax=+2.5)   !*** EXPERIMENTAL MAX TIME STEP OPTION - SPO 11/27/92 ***
      real  ridt, dtx, dt3, xvel, yvel, zvel, svel, t1
     &     ,width, widthy, widthz
C      
C------------------------------------------------------------------------
C
C   Hydro constraint on timestep.  Use R*d(theta) if y geometry is angular
      ridt = 0.

c      write(6,*)'DHC (dtcon): in dtcon at top; imax =',imax
C
      if(ndim .eq. 1) then
         j = 1
         k = 1
         do 10 i = 1, imax
            svel = sqrt(gam*zp(i,j,k)/zrho(i,j,k))/zdx(i)
            xvel = abs(zux(i,j,k)) / zdx(i)
            ridt = max(xvel,svel,ridt)
 10      continue
      else if(ndim .eq. 2) then
         k = 1
         do 20 j = 1, jmax
         do 20 i = 1, imax
            widthy = cvmgp(1.,zxa(i)+0.5*zdx(i),float(2-ngeomy))*zdy(j)
            width  = min(zdx(i),widthy)
            svel = sqrt(gam*zp(i,j,k)/zrho(i,j,k))/width
            xvel = abs(zux(i,j,k)) / zdx(i)
            yvel = abs(zuy(i,j,k)) / widthy
            ridt = max(xvel,yvel,svel,ridt)
 20      continue
      else if(ndim .eq. 3) then 
         do 30 k = 1, kmax
         do 30 j = 1, jmax
         do 30 i = 1, imax
            widthy = cvmgp(1.,zxa(i)+0.5*zdx(i),float(2-ngeomy))*zdy(j)
            widthz = cvmgp(1.,zxa(i)+0.5*zdx(i),float(2-ngeomz))*zdz(k)
            widthz = cvmgz(widthz*sin(zya(j)+.5*zdy(j)),widthz,float(5-ngeomz))
            width  = min(zdx(i),widthy,widthz)
            svel = sqrt(gam*zp(i,j,k)/zrho(i,j,k))/width
            xvel = abs(zux(i,j,k)) / zdx(i)
            yvel = abs(zuy(i,j,k)) / widthy
            zvel = abs(zuz(i,j,k)) / widthz
            ridt = max(xvel,yvel,zvel,svel,ridt)
 30      continue
      endif

c      write(6,*)'DHC (dtcon): svel,xvel,ridt =',svel,xvel,ridt

C
C global time constraint for given courant parameter
      dtx = courant / ridt

c      write(6,*)'DHC (dtcon): dtx just set'
c      write(6,*)'DHC (dtcon): courant,ridt,dtx,dtmax',courant,ridt,dtx,dtmax


      if (dtmax.gt.0.) dtx = min(dtmax,dtx)
C                                        
C limiting constraint on rate of increase of dt
      dt3 = 1.1 * dt
C                                        
C use smallest required timestep                                        
c      dt = amin1( dt3, dtx )

c      write(6,*)'DHC (dtcon): dt3, dtx, dt = ',dt3,dtx,dt
c      write(6,*)' '

      dt = min( dt3, dtx )
C
C if timestep becomes too small, stop the program!
      if (time/dt .gt. 1.e7) then
         write(*,*) 'Timestep has become too small: dt = ',dt
         write(*,*) '                             time = ',time
         write(*,*) '                           ncycle = ',ncycle
	 call tdpltprn(11,12)		! [note stdnew, stdout unknown here]
         call cpu_time(t1) 
         write(*,*),'CPU-seconds used: ',t1
         write(*,*),'Simulation stopped'
c         call prin(prefx)
         stop
      endif
C
      return
      end
