      subroutine gridx(nzones, xmin, xmax, xa, dx, dxfac)
c
C Create grid to cover physical size from xmin to xmax
C number of physical grid zones is nzones
C
C xa(1) is left boundary location - at xmin
C xa(nzones+1) is right boundary location - at xmax
C
      integer nzones
      real xmin, xmax, dxfac, tmp, tmps
      real xa(nzones), dx(nzones)
C
C LOCALS
C
C
C=======================================================================
C
C First, compute LBC dx
C
      tmp = 1.
      tmps= 1. 
      do n=2,nzones
	  tmps = tmps*dxfac
          tmp  = tmp+tmps
      enddo
      dx(1) = (xmax-xmin)/tmp
      xa(1) = xmin
C
C Now, fill in dx(n), incrementing by factor dxfac each time.
C
      do n=2,nzones
         xa(n) = xa(n-1) + dx(n-1)
         dx(n) = dxfac*dx(n-1)
      enddo
C
      return
      end
