PRO pt,dir,tst,tend,nm,lagt,lagv,yv=yv,eend=eend 

;restore,'vh1.out.sav'
;Follow a Lagrangian mass-parcel through the wind
;Stored in lagm variable

;ssf inputs
IF NOT keyword_set(eend) THEN model=dir+'vh1.out' ELSE model=dir+'vh1.out'+eend
read_mod,model,r,v,rho,dvdr,temp,lagm,time,dt,ncycle
lagm = lagm*4.*!pi
;Correct for 4 pi steriadians in lagrangian mass-coordinate 

;nm = 500
;tst  = 80000
;tend = 180000
ii = where(time ge tst)
nnl = n_elements(lagm(*,0))
mst  = lagm(nnl-1,ii(0)) 
ii = where(time ge tend)
mend  = lagm(nnl-1,ii(0)) 
mtracks = findgen(nm)/(nm-1)*(mend-mst)+mst
dm = mtracks(2)-mtracks(1)
dmt = mtracks(30)-mtracks(29)
IF (abs(dmt-dm)/dmt gt 1e-4) then begin 
   print,mtracks
   Message,'Not equal dm steps!'
ENDIF
print,'mst,mend,dm: ',mst,mend,dm

;NTOE: output matrices always of size nb,1000
;Thus -- what's the number of actually printed snaps? 
ii = where(v(0,*) eq 0.0,count)
if not (count eq 0) then begin 
   nb = ii(0)-1  
endif else begin 
   nb = n_elements(r(0,*))
endelse
nel = n_elements(r(*,0))
print,nb,' number of snaps have been printed in output file'
print,nel,' number of grid-points per snapshot'


lagt = Fltarr(nb,nm)
lagv = Fltarr(nb,nm) 
xr = [0,400e3]
IF NOT KEYWORD_SET(yv) THEN yr = [0,5e8] ELSE yr=yv

FOR j=0,nm-1 DO BEGIN 
   
   FOR i=0,nb-1 DO BEGIN 
      lagmsn = lagm(*,i)
      ii = where(lagmsn le mtracks(j), countle)
      IF (countle GT 0 AND countle LT nel) THEN BEGIN 
                                ;Particle identified in wind 
         lagt(i,j) = time(i)
         
                                ;Now take an average velocity of the particle? 
                                ;First -- test to take the lower..
         iden = [ii(0)-1,ii(0)]
         vint = interpol(v(iden,i),lagmsn(iden),mtracks(j))
         lagv(i,j) = vint
      ENDIF
   ENDFOR
   kk = where(lagt(*,j) gt 0.0,count)
   IF (count EQ 0) THEN Message,'No mass-parcel found?'
   IF (j eq 0) THEN cgplot,lagt(kk,j),lagv(kk,j),xr=xr,xs=1,yr=yr,ys=1 ELSE $
      cgplot,lagt(kk,j),lagv(kk,j),/overplot

ENDFOR

END

