pro plot_tseq,dir,loop=loop,eend=eend,ddt=ddt,xr=xr,yrho=yrho,yv=yv,nosav=nosav,xlog=xlog,lag=lag,rstar=rstar,gif=gif,cakplot=cakplot

IF (N_Params() NE 1) THEN BEGIN 
   print,'Input:plot_tseq,dir,loop=loop,eend=eend,ddt=ddt,xr=xr,yrho=yrho,yv=yv,nosav=nosav,xlog=xlog,lag=lag,rstar=rstar,gif=gif,cakplot=cakplot'
   Return
ENDIF


@cgs_constants
window,0
!P.Multi=[0,1,3]
!y.charsize=2.0
!x.charsize=2.0
p1 = [0.12,0.12,0.95,0.39]
p2 = [0.12,0.41,0.95,0.68]
p3 = [0.12,0.7,0.95,0.97]

if not keyword_set(xr) then   xr=[1.,10.]
IF NOT keyword_set(xlog) THEN xlog=0 ELSE xlog=1
IF NOT keyword_set(loop) THEN loop=1
IF NOT keyword_set(eend) THEN model=dir+'vh1.out' ELSE model=dir+'vh1.out'+eend
IF NOT keyword_set(eend) THEN model_fcl=dir+'vh1.stat' ELSE model_fcl=dir+'vh1.stat'+eend

;ssf inputs
read_mod,model,r,v,rho,dvdr,temp,lagm,time,dt,ncycle,sf,so,grad,gscat
if not keyword_set(nosav) then begin 
   save,filename='vh1.out.sav',r,v,rho,dvdr,temp,time,dt,lagm,ncycle,sf,so,grad,gscat
   print,'data saved in save-set vh1.out.sav'
endif
;------------------
;restore,file1


;what's the number of printed snaps? 
ii = where(v(0,*) eq 0.0,count)
if not (count eq 0) then begin 
   nb = ii(0)-1  
endif else begin 
   nb = n_elements(r(0,*))
endelse
print,nb,' number of snaps will be plotted'
print,'in',loop,' number of loops'

vnorm=max(v(*,0))

r_sm=r(*,0)+1.
v_sm=v(*,0);/vnorm
rho_sm=rho(*,0)
temp_sm = temp(*,0)
vlim = max(v_sm)+1.e8
yvcak = [0.0,vlim]
yrhocak = [1e-22,max(rho_sm*10.)]
IF KEYWORD_SET(lag) THEN xr=[max(lagm(*,0))*1.02,min(lagm(*,0))*0.98]

if not keyword_set(yrho) then yrho=yrhocak
if not keyword_set(yv) then yv=yvcak 
if not keyword_set(ddt) then ddt=0.5

for j=0L,loop-1 do begin
   print,'loop number:',j+1
   for i=0L,nb-1 do begin 
      wait,ddt
      rr = r(*,i)+1.
      IF KEYWORD_SET(lag) THEN rr=lagm(*,i)
      IF KEYWORD_SET(lag) THEN xr=[max(lagm(*,i))*1.02,min(lagm(*,i))*0.98]
      vv = v(*,i);/vnorm
      rhorho = rho(*,i)
      tt = temp(*,i)
      timet = time(i)
;Take out a patch
      IF KEYWORD_SET(lag) THEN xtit=textoidl('m [g]') ELSE xtit=textoidl('r/R_{*}')
      cgplot,rr,rhorho,/ylog,xr=xr,xs=1,ys=1,yr=yrho,position=p1,xlog=xlog,$
             ytitle=textoidl('\rho [g/cm^3]'),xtitle=xtit
      If keyword_set(cakplot) then cgplot,r_sm,rho_sm,/overplot
      cgplot,[1.5,1.5],[1e-30,1.],linestyle=2,thick=1,/overplot
      cgplot,[5.0,5.0],[1e-30,1.],linestyle=2,thick=1,/overplot

      IF KEYWORD_SET(lag) THEN BEGIN 
         tet = 'time = ' + string(timet(0)/1000., format = '(f5.1)') + ' Ksec'
         cgtext,0.15,0.15,tet,col=cgcolor('black'),/NORMAL
      ENDIF ELSE BEGIN  
         tet = 'time = ' + string(timet(0)/1000., format = '(f5.1)') + ' Ksec'
         cgtext,1.6,yrho(0)*1e1,tet,col=cgcolor('black')
      ENDELSE
;density plot

      cgplot,rr,vv,xr=xr,xs=1,ys=1,yr=yv,position=p2,xlog=xlog,$
             xtickname=replicate(' ',20),ytitle=textoidl('v_r [cm/s]'),psym=8 
      if keyword_set(cakplot) then cgplot,r_sm,v_sm,/overplot
      cgplot,[1.5,1.5],[0,1.e9],linestyle=2,thick=1,/overplot
      cgplot,[5.0,5.0],[0,1.e9],linestyle=2,thick=1,/overplot
;velocity plot

      cgplot,rr,tt,xr=xr,xs=1,ys=1,yr=[1e4,1e8],position=p3,xlog=xlog,/ylog,$
             xtickname=replicate(' ',20),ytitle=textoidl('T [K]')   
      if keyword_set(cakplot) then cgplot,r_sm,temp_sm,/overplot
      cgplot,[1.5,1.5],[1.,1.e9],linestyle=2,thick=1,/overplot
      cgplot,[5.0,5.0],[1.,1.e9],linestyle=2,thick=1,/overplot
;Make an gif-image output? 
      IF KEYWORD_SET(gif) THEN BEGIN 
         filegif = 'frame'+string(i, format = '(i4.4)')+'.gif'
         write_gif,filegif,tvrd()
      ENDIF
;another one? 
;print,'plot next snap? - press 1'
   endfor 
endfor

;Now finalize with fcl and mass-parcel plot (the latter if lag)
window,1
!p.multi=0
!y.charsize=1.3
!x.charsize=1.3
;readcol,model_fcl,rfcl,rhoav,rho2av,fcl
;yrfcl=[0.0,max(fcl)+10.]
;cgplot,rfcl+1.,fcl,xr=xr,xs=1,ys=1,yr=yrfcl,xlog=xlog,$
;       ytitle=textoidl('f_{cl}'),xtitle=textoidl('r/R_{*}')

IF KEYWORD_SET(lag) THEN BEGIN 
   nm=50
   tst =1.0e4
   tend = time(nb-1)
   pt,dir,tst,tend,nm,lagt,lagv,yv=yv,eend=eend 
   if not keyword_set(nosav) then begin 
      save,filename='parc_track.sav',lagv,lagt
      print,'parcel track data saved in save-set parc_track.sav'
   endif
ENDIF

IF KEYWORD_SET(gif) THEN BEGIN 
   print,'Make gif-animation file'
;   spawn,'gifsicle --delay=10 --loopcount=1 frame*.gif > anim.gif'
   spawn,'gifsicle --delay=10 --loopcount=0 frame*.gif > anim.gif'
;Set the loop to forever as default 
   IF (gif gt 1) THEN spawn,'cp frame*.gif gif_snapshots/' ELSE $
      spawn,'rm frame*.gif'

   IF KEYWORD_SET(lag) THEN BEGIN 
      filegif = 'parc_track.gif'
      write_gif,filegif,tvrd()
   ENDIF
;NOTE, make sure i is still set.. 

ENDIF
      

end

@parc_track.pro
@read_mod.pro 
